---
updatedAt: 2026-05-15T19:08:46.000Z
agentTools:
  siteIndex: https://developers.pismo.io/llms.txt
  projectIndex: https://developers.pismo.io/pismo-docs/llms.txt
---

# List cards

Return active account card list

# OpenAPI definition

```json
{
  "openapi": "3.1.0",
  "info": {
    "title": "Instant payments - RuPay on UPI",
    "description": "United Payments Interface (UPI) API integrating providers with the Pismo platform",
    "contact": {
      "name": "Pismo"
    },
    "license": {
      "name": "Apache 2.0"
    },
    "version": "1.0"
  },
  "servers": [
    {
      "url": "https://sandbox.pismolabs.io/upi-gateway",
      "description": "Sandbox API server for testing"
    }
  ],
  "security": [
    {
      "BearerAuth": []
    }
  ],
  "tags": [
    {
      "name": "UPI",
      "description": "Endpoints to manage UPI operations"
    }
  ],
  "components": {
    "parameters": {
      "AuthHeader": {
        "in": "header",
        "name": "Authorization",
        "required": true,
        "description": "Authorization token. Tokens can expire quickly, which can result in a **401 Unauthorized** message.",
        "schema": {
          "type": "string",
          "example": "Bearer eyJhbGci...IUzUx"
        }
      },
      "UserAgentHeader": {
        "in": "header",
        "name": "user-agent",
        "required": true,
        "description": "Client consuming API.",
        "schema": {
          "type": "string"
        }
      }
    },
    "schemas": {
      "accountReferenceNumber": {
        "type": "string",
        "description": "\nAccount reference number. Pismo creates this automatically when creating a card linked to RuPay on UPI.\n\nThis number combines 10 BIN digits and the credit account number. If BIN is 6 digits, the remaining 4 digits  are set to zero (`0`). If BIN is 8 digits, then the remaining 2 digits are set to zero. This is a [NPCI](https://www.npci.org.in/what-we-do/rupay/product-overview) standard. For example, if the account reference number = `1234560000987654321`, the first six digits are the BIN, appended with 4 zeros and then the credit account number (`987654321``).\n\nYou can call [List cards](https://developers.pismo.io/pismo-docs/reference/post-list-cards) to get a card's account reference number.\n",
        "example": "12345600000000001140340134"
      },
      "cards.CardsData": {
        "type": "object",
        "required": [
          "account_reference_number",
          "bin",
          "masked_number",
          "printed_name",
          "status",
          "type"
        ],
        "properties": {
          "account_reference_number": {
            "$ref": "#/components/schemas/accountReferenceNumber"
          },
          "bin": {
            "type": "string",
            "description": "Card Bank Identification Number (BIN)",
            "example": "123456"
          },
          "masked_number": {
            "type": "string",
            "description": "Card masked number",
            "example": "123456XXXXXXXX78"
          },
          "printed_name": {
            "type": "string",
            "description": "Card printed name",
            "example": "Nan Tucket"
          },
          "status": {
            "type": "string",
            "description": "Card status. For more information, see [Card lifecycle and statuses](https://developers.pismo.io/pismo-docs/docs/card-lifecycle-and-statuses).",
            "example": "ACTIVE"
          },
          "type": {
            "$ref": "#/components/schemas/cardType"
          }
        }
      },
      "cards.ListCardsRequest": {
        "type": "object",
        "required": [
          "external_transaction_datetime",
          "external_transaction_id",
          "phone"
        ],
        "properties": {
          "external_transaction_datetime": {
            "$ref": "#/components/schemas/externalTransactionDatetime"
          },
          "external_transaction_id": {
            "$ref": "#/components/schemas/externalTransactionID"
          },
          "phone": {
            "$ref": "#/components/schemas/phone"
          },
          "type": {
            "$ref": "#/components/schemas/cardType"
          }
        }
      },
      "cards.ListCardsResponse": {
        "type": "object",
        "required": [
          "cards",
          "external_transaction_datetime",
          "external_transaction_id",
          "owner",
          "phone"
        ],
        "properties": {
          "cards": {
            "type": "array",
            "description": "Account cards",
            "items": {
              "$ref": "#/components/schemas/cards.CardsData"
            }
          },
          "external_transaction_datetime": {
            "$ref": "#/components/schemas/externalTransactionDatetime"
          },
          "external_transaction_id": {
            "$ref": "#/components/schemas/externalTransactionID"
          },
          "owner": {
            "type": "object",
            "description": "Account owner data",
            "allOf": [
              {
                "$ref": "#/components/schemas/cards.Owner"
              }
            ]
          },
          "phone": {
            "$ref": "#/components/schemas/phone"
          }
        }
      },
      "cards.Owner": {
        "type": "object",
        "required": [
          "name"
        ],
        "properties": {
          "name": {
            "type": "string",
            "description": "Owner name"
          }
        }
      },
      "cardType": {
        "type": "string",
        "description": "Pismo card type. For more information, see [Cards management](https://developers.pismo.io/pismo-docs/docs/cards-overview-1#card-types). Default is empty string, meaning all card types are returned.",
        "enum": [
          "",
          "PLASTIC",
          "VIRTUAL",
          "TEMPORARY"
        ],
        "example": "PLASTIC"
      },
      "domain.DetailMessage": {
        "type": "object",
        "properties": {
          "external": {
            "type": "array",
            "items": {
              "$ref": "#/components/schemas/domain.ExternalMessage"
            }
          },
          "parameters": {
            "type": "array",
            "items": {
              "$ref": "#/components/schemas/domain.ParameterMessage"
            }
          },
          "payload": {
            "type": "array",
            "items": {
              "$ref": "#/components/schemas/domain.PayloadMessage"
            }
          }
        }
      },
      "domain.Error": {
        "type": "object",
        "properties": {
          "code": {
            "type": "string",
            "description": "Error type code",
            "example": "EPT0001"
          },
          "details": {
            "type": "object",
            "description": "Detailed error message",
            "allOf": [
              {
                "$ref": "#/components/schemas/domain.DetailMessage"
              }
            ]
          },
          "message": {
            "type": "string",
            "description": "Error message",
            "example": "User not found"
          }
        }
      },
      "domain.ExternalMessage": {
        "type": "object",
        "required": [
          "code",
          "message"
        ],
        "properties": {
          "code": {
            "type": "string",
            "description": "Code",
            "example": "PBE315"
          },
          "message": {
            "type": "string",
            "description": "Message",
            "example": "Generic error"
          }
        }
      },
      "domain.ParameterMessage": {
        "type": "object",
        "required": [
          "field",
          "message"
        ],
        "properties": {
          "field": {
            "type": "string",
            "description": "Field",
            "example": "Query parameter"
          },
          "message": {
            "type": "string",
            "description": "Message",
            "example": "Generic error"
          }
        }
      },
      "domain.PayloadMessage": {
        "type": "object",
        "required": [
          "field",
          "message"
        ],
        "properties": {
          "field": {
            "type": "string",
            "description": "Field",
            "example": "Entity.field"
          },
          "message": {
            "type": "string",
            "description": "Error message",
            "example": "Generic error"
          }
        }
      },
      "externalTransactionDatetime": {
        "type": "string",
        "description": "Request datetime. ISO 8601 format.",
        "example": "2020-09-15T19:39:54.013Z"
      },
      "externalTransactionID": {
        "type": "string",
        "description": "Request ID code",
        "example": "MGS584A1244F6BC4D50A3FABE6D93DF913C"
      },
      "phone": {
        "type": "object",
        "required": [
          "country_code",
          "phone"
        ],
        "properties": {
          "country_code": {
            "type": "string",
            "description": "Phone number country code",
            "example": "55"
          },
          "phone": {
            "type": "string",
            "description": "Phone number",
            "example": "999167803"
          },
          "area_code": {
            "type": "string",
            "description": "Phone number area code",
            "example": "47"
          }
        },
        "example": {
          "country_code": "91",
          "phone": "9592714958"
        }
      }
    },
    "securitySchemes": {
      "BearerAuth": {
        "type": "http",
        "scheme": "bearer",
        "description": "Account token - token encoded with a Pismo account ID. Tokens can expire quickly, which can result in a **401 Unauthorized** error.\n",
        "bearerFormat": "JWT"
      }
    }
  },
  "paths": {
    "/v1/cards/list": {
      "post": {
        "summary": "List cards",
        "description": "Return active account card list",
        "operationId": "post-list-cards",
        "tags": [
          "UPI"
        ],
        "parameters": [
          {
            "$ref": "#/components/parameters/AuthHeader"
          },
          {
            "$ref": "#/components/parameters/UserAgentHeader"
          }
        ],
        "requestBody": {
          "description": "Request Body",
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/cards.ListCardsRequest"
              }
            }
          },
          "required": true
        },
        "responses": {
          "200": {
            "description": "Response Body",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/cards.ListCardsResponse"
                }
              }
            }
          },
          "400": {
            "description": "Bad Request",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/domain.Error"
                },
                "examples": {
                  "EUPI0003": {
                    "summary": "Bad Request",
                    "value": {
                      "code": "EUPI0003",
                      "message": "Bad Request"
                    }
                  },
                  "EUPI0023": {
                    "summary": "number is a required field",
                    "value": {
                      "code": "EUPI0023",
                      "message": "number is a required field"
                    }
                  },
                  "EUPI0002": {
                    "summary": "Validation error",
                    "value": {
                      "code": "EUPI0002",
                      "message": "Validation error"
                    }
                  }
                }
              }
            }
          },
          "403": {
            "description": "Forbidden",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/domain.Error"
                },
                "examples": {
                  "EUPI0004": {
                    "summary": "Missing required header 'x-tenant'",
                    "value": {
                      "code": "EUPI0004",
                      "message": "Missing required header 'x-tenant'"
                    }
                  }
                }
              }
            }
          },
          "404": {
            "description": "Not Found",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/domain.Error"
                },
                "examples": {
                  "EUPI0028": {
                    "summary": "Cards not found.",
                    "value": {
                      "code": "EUPI0028",
                      "message": "Cards not found."
                    }
                  },
                  "EUPI0032": {
                    "summary": "Not found.",
                    "value": {
                      "code": "EUPI0032",
                      "message": "Not found."
                    }
                  },
                  "EUPI0007": {
                    "summary": "Account not found.",
                    "value": {
                      "code": "EUPI0007",
                      "message": "Account not found."
                    }
                  }
                }
              }
            }
          },
          "409": {
            "description": "Conflict",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/domain.Error"
                },
                "examples": {
                  "EUPI0024": {
                    "summary": "card type invalid",
                    "value": {
                      "code": "EUPI0024",
                      "message": "card type invalid"
                    }
                  },
                  "EUPI0014": {
                    "summary": "Not unique owner for the phone number",
                    "value": {
                      "code": "EUPI0014",
                      "message": "Not unique owner for the phone number"
                    }
                  }
                }
              }
            }
          },
          "422": {
            "description": "UnprocessableEntity",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/domain.Error"
                },
                "examples": {
                  "EUPI0004": {
                    "summary": "An unexpected error has occurred",
                    "value": {
                      "code": "EUPI0042",
                      "message": "An unexpected error has occurred"
                    }
                  }
                }
              }
            }
          },
          "500": {
            "description": "Internal Server Error",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/domain.Error"
                },
                "examples": {
                  "EUPI0001": {
                    "summary": "An unexpected error happened",
                    "value": {
                      "code": "EUPI0001",
                      "message": "An unexpected error happened"
                    }
                  }
                }
              }
            }
          }
        }
      }
    }
  }
}
```